function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { JoinColumn, ManyToOne, Entity, PrimaryColumn, Index, Column } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let DriveFolder = class DriveFolder {
    id;
    createdAt;
    name;
    userId;
    user;
    parentId;
    parent;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], DriveFolder.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the DriveFolder."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], DriveFolder.prototype, "createdAt", void 0);
_ts_decorate([
    Column("varchar", {
        length: 128,
        comment: "The name of the DriveFolder."
    }),
    _ts_metadata("design:type", String)
], DriveFolder.prototype, "name", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true,
        comment: "The owner ID."
    }),
    _ts_metadata("design:type", Object)
], DriveFolder.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], DriveFolder.prototype, "user", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true,
        comment: "The parent folder ID. If null, it means the DriveFolder is located in root."
    }),
    _ts_metadata("design:type", Object)
], DriveFolder.prototype, "parentId", void 0);
_ts_decorate([
    ManyToOne((type)=>DriveFolder, {
        onDelete: "SET NULL"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], DriveFolder.prototype, "parent", void 0);
DriveFolder = _ts_decorate([
    Entity()
], DriveFolder);
